Index: code/trunk/src/orxonox/gamestates/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/gamestates/CMakeLists.txt	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/CMakeLists.txt	(revision 5693)
@@ -1,3 +1,3 @@
-ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+SET_SOURCE_FILES(GAMESTATES_SRC_FILES
   GSClient.cc
   GSDedicated.cc
@@ -10,2 +10,11 @@
   GSStandalone.cc
 )
+
+ORXONOX_ADD_LIBRARY(gamestates
+  MODULE
+  DEFINE_SYMBOL
+    "GAMESTATES_SHARED_BUILD"
+  LINK_LIBRARIES
+    orxonox
+  SOURCE_FILES ${GAMESTATES_SRC_FILES}
+)
Index: code/trunk/src/orxonox/gamestates/GSClient.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSClient.cc	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSClient.cc	(revision 5693)
@@ -40,5 +40,5 @@
     DeclareGameState(GSClient, "client", false, true);
 
-    SetCommandLineArgument(ip, "127.0.0.1").information("Sever IP as strin in the form #.#.#.#");
+    SetCommandLineArgument(ip, "127.0.0.1").information("Sever IP as string in the form #.#.#.#");
 
     GSClient::GSClient(const GameStateInfo& info)
Index: code/trunk/src/orxonox/gamestates/GSClient.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSClient.h	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSClient.h	(revision 5693)
@@ -30,5 +30,5 @@
 #define _GSClient_H__
 
-#include "OrxonoxPrereqs.h"
+#include "gamestates/GameStatesPrereqs.h"
 
 #include "core/GameState.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport GSClient : public GameState
+    class _GameStatesExport GSClient : public GameState
     {
     public:
Index: code/trunk/src/orxonox/gamestates/GSDedicated.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSDedicated.h	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSDedicated.h	(revision 5693)
@@ -30,5 +30,5 @@
 #define _GSDedicated_H__
 
-#include "OrxonoxPrereqs.h"
+#include "gamestates/GameStatesPrereqs.h"
 
 #include "core/GameState.h"
@@ -44,6 +44,6 @@
 namespace orxonox
 {
-    
-    class _OrxonoxExport GSDedicated : public GameState
+
+    class _GameStatesExport GSDedicated : public GameState
     {
     public:
@@ -61,10 +61,10 @@
         void setTerminalMode();
         static void resetTerminalMode();
-        
+
         void insertCharacter( unsigned int position, char c );
         void deleteCharacter( unsigned int position );
-        
+
         Server*                 server_;
-        
+
         boost::thread           *inputThread_;
         boost::recursive_mutex  inputLineMutex_;
@@ -76,5 +76,5 @@
         std::queue<std::string> commandQueue_;
         static termios*         originalTerminalSettings_;
-        
+
         unsigned int            cursorX_;
         unsigned int            cursorY_;
Index: code/trunk/src/orxonox/gamestates/GSGraphics.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSGraphics.cc	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSGraphics.cc	(revision 5693)
@@ -47,9 +47,9 @@
 #include "core/Loader.h"
 #include "core/XMLFile.h"
-#include "overlays/console/InGameConsole.h"
+#include "InGameConsole.h"
 #include "sound/SoundManager.h"
 
 // HACK:
-#include "overlays/map/Map.h"
+#include "Map.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/gamestates/GSGraphics.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSGraphics.h	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSGraphics.h	(revision 5693)
@@ -36,5 +36,5 @@
 #define _GSGraphics_H__
 
-#include "OrxonoxPrereqs.h"
+#include "gamestates/GameStatesPrereqs.h"
 #include "core/GameState.h"
 
@@ -47,5 +47,5 @@
         This game state is only left out if we start a dedicated server where no graphics are present.
     */
-    class _OrxonoxExport GSGraphics : public GameState
+    class _GameStatesExport GSGraphics : public GameState
     {
     public:
Index: code/trunk/src/orxonox/gamestates/GSIOConsole.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSIOConsole.h	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSIOConsole.h	(revision 5693)
@@ -30,10 +30,10 @@
 #define _GSIOConsole_H__
 
-#include "OrxonoxPrereqs.h"
+#include "gamestates/GameStatesPrereqs.h"
 #include "core/GameState.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSIOConsole : public GameState
+    class _GameStatesExport GSIOConsole : public GameState
     {
     public:
Index: code/trunk/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 5693)
@@ -45,8 +45,6 @@
 #include "core/XMLFile.h"
 
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 #include "objects/Radar.h"
-#include "objects/quest/QuestManager.h"
-#include "overlays/notifications/NotificationManager.h"
 #include "CameraManager.h"
 #include "LevelManager.h"
@@ -110,7 +108,5 @@
         this->playerManager_ = new PlayerManager();
 
-        this->questManager_ = new QuestManager();
-
-        this->notificationManager_ = new NotificationManager();
+        this->scope_GSLevel_ = new Scope<ScopeID::GSLevel>();
 
         if (GameMode::isMaster())
@@ -201,14 +197,8 @@
         }
 
-        if (this->questManager_)
-        {
-            delete this->questManager_;
-            this->questManager_ = NULL;
-        }
-
-        if (this->notificationManager_)
-        {
-            delete this->notificationManager_;
-            this->notificationManager_ = NULL;
+        if (this->scope_GSLevel_)
+        {
+            delete this->scope_GSLevel_;
+            this->scope_GSLevel_ = NULL;
         }
 
Index: code/trunk/src/orxonox/gamestates/GSLevel.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSLevel.h	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSLevel.h	(revision 5693)
@@ -30,7 +30,8 @@
 #define _GSLevel_H__
 
-#include "OrxonoxPrereqs.h"
+#include "gamestates/GameStatesPrereqs.h"
 
 #include <string>
+#include "util/Scope.h"
 #include "core/OrxonoxClass.h"
 #include "core/GameState.h"
@@ -38,5 +39,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport GSLevel : public GameState, public OrxonoxClass
+    class _GameStatesExport GSLevel : public GameState, public OrxonoxClass
     {
     public:
@@ -62,13 +63,12 @@
         void keybindInternal(const std::string& command, bool bTemporary);
 
-        KeyBinder*            keyBinder_;               //!< tool that loads and manages the input bindings
-        InputState*           gameInputState_;          //!< input state for normal ingame playing
-        InputState*           guiMouseOnlyInputState_;  //!< input state if we only need the mouse to use the GUI
-        InputState*           guiKeysOnlyInputState_;   //!< input state if we only need the keys to use the GUI
-        Radar*                radar_;                   //!< represents the Radar (not the HUD part)
-        CameraManager*        cameraManager_;           //!< camera manager for this level
-        PlayerManager*        playerManager_;           //!< player manager for this level
-        QuestManager*         questManager_;
-        NotificationManager*  notificationManager_;
+        KeyBinder*               keyBinder_;               //!< tool that loads and manages the input bindings
+        InputState*              gameInputState_;          //!< input state for normal ingame playing
+        InputState*              guiMouseOnlyInputState_;  //!< input state if we only need the mouse to use the GUI
+        InputState*              guiKeysOnlyInputState_;   //!< input state if we only need the keys to use the GUI
+        Radar*                   radar_;                   //!< represents the Radar (not the HUD part)
+        CameraManager*           cameraManager_;           //!< camera manager for this level
+        PlayerManager*           playerManager_;           //!< player manager for this level
+        Scope<ScopeID::GSLevel>* scope_GSLevel_;
 
         //##### ConfigValues #####
Index: code/trunk/src/orxonox/gamestates/GSMainMenu.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSMainMenu.h	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSMainMenu.h	(revision 5693)
@@ -30,5 +30,5 @@
 #define _GSMainMenu_H__
 
-#include "OrxonoxPrereqs.h"
+#include "gamestates/GameStatesPrereqs.h"
 
 #include "util/OgreForwardRefs.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport GSMainMenu : public GameState
+    class _GameStatesExport GSMainMenu : public GameState
     {
     public:
Index: code/trunk/src/orxonox/gamestates/GSRoot.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSRoot.cc	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSRoot.cc	(revision 5693)
@@ -38,6 +38,6 @@
 #include "ToluaBindOrxonox.h"
 #include "tools/Timer.h"
-#include "interfaces/TimeFactorListener.h"
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/TimeFactorListener.h"
+#include "tools/interfaces/Tickable.h"
 #include "LevelManager.h"
 
Index: code/trunk/src/orxonox/gamestates/GSRoot.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSRoot.h	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSRoot.h	(revision 5693)
@@ -30,10 +30,10 @@
 #define _GSRoot_H__
 
-#include "OrxonoxPrereqs.h"
+#include "gamestates/GameStatesPrereqs.h"
 #include "core/GameState.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSRoot : public GameState
+    class _GameStatesExport GSRoot : public GameState
     {
     public:
Index: code/trunk/src/orxonox/gamestates/GSServer.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSServer.h	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSServer.h	(revision 5693)
@@ -30,5 +30,5 @@
 #define _GSServer_H__
 
-#include "OrxonoxPrereqs.h"
+#include "gamestates/GameStatesPrereqs.h"
 
 #include "core/GameState.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport GSServer : public GameState
+    class _GameStatesExport GSServer : public GameState
     {
     public:
Index: code/trunk/src/orxonox/gamestates/GSStandalone.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSStandalone.h	(revision 5692)
+++ code/trunk/src/orxonox/gamestates/GSStandalone.h	(revision 5693)
@@ -30,10 +30,10 @@
 #define _GSStandalone_H__
 
-#include "OrxonoxPrereqs.h"
+#include "gamestates/GameStatesPrereqs.h"
 #include "core/GameState.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSStandalone : public GameState
+    class _GameStatesExport GSStandalone : public GameState
     {
     public:
Index: code/trunk/src/orxonox/gamestates/GameStatesPrereqs.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GameStatesPrereqs.h	(revision 5693)
+++ code/trunk/src/orxonox/gamestates/GameStatesPrereqs.h	(revision 5693)
@@ -0,0 +1,60 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+  @file
+  @brief Contains all the necessary forward declarations for all classes and structs.
+*/
+
+#ifndef _GameStatesPrereqs_H__
+#define _GameStatesPrereqs_H__
+
+#include "OrxonoxConfig.h"
+
+#include "OrxonoxPrereqs.h"
+
+//-----------------------------------------------------------------------
+// Shared library settings
+//-----------------------------------------------------------------------
+#if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(ORXONOX_STATIC_BUILD)
+#  ifdef GAMESTATES_SHARED_BUILD
+#    define _GameStatesExport __declspec(dllexport)
+#  else
+#    if defined( __MINGW32__ )
+#      define _GameStatesExport
+#    else
+#      define _GameStatesExport __declspec(dllimport)
+#    endif
+#  endif
+#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _GameStatesExport  __attribute__ ((visibility("default")))
+#else
+#  define _GameStatesExport
+#endif
+
+#endif /* _GameStatesPrereqs_H__ */
Index: code/trunk/src/orxonox/interfaces/InterfaceCompilation.cc
===================================================================
--- code/trunk/src/orxonox/interfaces/InterfaceCompilation.cc	(revision 5692)
+++ code/trunk/src/orxonox/interfaces/InterfaceCompilation.cc	(revision 5693)
@@ -30,5 +30,5 @@
 @file
 @brief
-    Compiles all the interfaces (except RadarViewable) with mostly just a constructor.
+    Compiles all the interfaces in the orxonox library with mostly just a constructor.
 */
 
@@ -38,6 +38,5 @@
 #include "Rewardable.h"
 #include "TeamColourable.h"
-#include "Tickable.h"
-#include "TimeFactorListener.h"
+#include "NotificationListener.h"
 
 #include "core/CoreIncludes.h"
@@ -81,25 +80,4 @@
 
     //----------------------------
-    // TimeFactorListener
-    //----------------------------
-    float TimeFactorListener::timefactor_s = 1.0f;
-
-    TimeFactorListener::TimeFactorListener()
-    {
-        RegisterRootObject(TimeFactorListener);
-    }
-
-    //----------------------------
-    // Tickable
-    //----------------------------
-    /**
-        @brief Constructor: Registers the object in the Tickable-list
-    */
-    Tickable::Tickable()
-    {
-        RegisterRootObject(Tickable);
-    }
-
-    //----------------------------
     // Rewardable
     //----------------------------
@@ -108,3 +86,11 @@
         RegisterObject(Rewardable);
     }
+
+    //----------------------------
+    // NotificationListener
+    //----------------------------
+    NotificationListener::NotificationListener()
+    {
+        RegisterObject(NotificationListener);
+    }
 }
Index: code/trunk/src/orxonox/interfaces/NotificationListener.h
===================================================================
--- code/trunk/src/orxonox/interfaces/NotificationListener.h	(revision 5693)
+++ code/trunk/src/orxonox/interfaces/NotificationListener.h	(revision 5693)
@@ -0,0 +1,59 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Definition of the NotificationListener class.
+*/
+
+#ifndef _NotificationListener_H__
+#define _NotificationListener_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <ctime>
+#include <set>
+#include <string>
+
+#include "core/OrxonoxClass.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport NotificationListener : virtual public OrxonoxClass
+    {
+        public:
+            NotificationListener();
+            virtual ~NotificationListener() {}
+
+            virtual const std::set<std::string> & getTargetsSet() = 0;
+            virtual void update(void) = 0;
+            virtual void update(Notification* notification, const std::time_t & time) = 0;
+    };
+}
+
+#endif /* _NotificationListener_H__ */
Index: code/trunk/src/orxonox/interfaces/RadarViewable.cc
===================================================================
--- code/trunk/src/orxonox/interfaces/RadarViewable.cc	(revision 5692)
+++ code/trunk/src/orxonox/interfaces/RadarViewable.cc	(revision 5693)
@@ -38,5 +38,5 @@
 #include "objects/worldentities/WorldEntity.h"
 #include "objects/Radar.h"
-#include "overlays/map/Map.h"
+#include "Map.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/objects/Radar.h
===================================================================
--- code/trunk/src/orxonox/objects/Radar.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/Radar.h	(revision 5693)
@@ -42,5 +42,5 @@
 #include "core/ObjectListIterator.h"
 #include "interfaces/RadarViewable.h"
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/objects/Scene.h
===================================================================
--- code/trunk/src/orxonox/objects/Scene.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/Scene.h	(revision 5693)
@@ -41,5 +41,5 @@
 #include "core/BaseObject.h"
 #include "network/synchronisable/Synchronisable.h"
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/objects/Test.h
===================================================================
--- code/trunk/src/orxonox/objects/Test.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/Test.h	(revision 5693)
@@ -33,5 +33,5 @@
 #include "core/BaseObject.h"
 #include "network/synchronisable/Synchronisable.h"
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 
 
@@ -50,5 +50,5 @@
       void setConfigValues();
       void registerVariables();
-      
+
       static void call(unsigned int clientID);
       void call2(unsigned int clientID, std::string s1, std::string s2, std::string s3, std::string s4);
@@ -65,5 +65,5 @@
       void checkU3();
       void checkU4();
-      
+
       //signed functions
       void setS1(TYPE value){ s1 = value; }
@@ -75,10 +75,10 @@
       void checkS3();
       void checkS4();
-      
+
       static void printV1(){ instance_->checkU1(); }
       static void printV2(){ instance_->checkU2(); }
       static void printV3(){ instance_->checkU3(); }
       static void printV4(){ instance_->checkU4(); }
-      
+
       void printBlaBla(std::string s1, std::string s2, std::string s3, std::string s4, std::string s5);
 
@@ -88,10 +88,10 @@
       UTYPE u3;
       UTYPE u4;
-      
+
       TYPE s1;
       TYPE s2;
       TYPE s3;
       TYPE s4;
-      
+
       static Test* instance_;
   };
Index: code/trunk/src/orxonox/objects/controllers/AIController.h
===================================================================
--- code/trunk/src/orxonox/objects/controllers/AIController.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/controllers/AIController.h	(revision 5693)
@@ -33,5 +33,5 @@
 
 #include "tools/Timer.h"
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 #include "ArtificialController.h"
 
Index: code/trunk/src/orxonox/objects/controllers/HumanController.cc
===================================================================
--- code/trunk/src/orxonox/objects/controllers/HumanController.cc	(revision 5692)
+++ code/trunk/src/orxonox/objects/controllers/HumanController.cc	(revision 5693)
@@ -35,5 +35,5 @@
 #include "objects/gametypes/Gametype.h"
 #include "objects/infos/PlayerInfo.h"
-#include "overlays/map/Map.h"
+#include "Map.h"
 
 namespace orxonox
Index: code/trunk/src/orxonox/objects/controllers/PongAI.h
===================================================================
--- code/trunk/src/orxonox/objects/controllers/PongAI.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/controllers/PongAI.h	(revision 5693)
@@ -34,5 +34,5 @@
 #include <list>
 #include "util/Math.h"
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 #include "Controller.h"
 
Index: code/trunk/src/orxonox/objects/controllers/WaypointController.h
===================================================================
--- code/trunk/src/orxonox/objects/controllers/WaypointController.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/controllers/WaypointController.h	(revision 5693)
@@ -33,5 +33,5 @@
 
 #include <vector>
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 #include "ArtificialController.h"
 
Index: code/trunk/src/orxonox/objects/gametypes/Gametype.h
===================================================================
--- code/trunk/src/orxonox/objects/gametypes/Gametype.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/gametypes/Gametype.h	(revision 5693)
@@ -38,5 +38,5 @@
 #include "core/BaseObject.h"
 #include "core/Identifier.h"
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 #include "objects/infos/GametypeInfo.h"
 
@@ -133,5 +133,5 @@
 
             inline  void startTimer()
-            { 
+            {
                 this->time_ = this->timeLimit_;
                 this->timerIsActive_ = true;
Index: code/trunk/src/orxonox/objects/items/Engine.h
===================================================================
--- code/trunk/src/orxonox/objects/items/Engine.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/items/Engine.h	(revision 5693)
@@ -32,5 +32,5 @@
 #include "OrxonoxPrereqs.h"
 
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 #include "Item.h"
 
Index: code/trunk/src/orxonox/objects/pickup/DroppedItem.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/DroppedItem.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/pickup/DroppedItem.h	(revision 5693)
@@ -38,5 +38,5 @@
 
 #include "tools/Timer.h"
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 #include "objects/worldentities/StaticEntity.h"
 
Index: code/trunk/src/orxonox/objects/pickup/PickupSpawner.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/PickupSpawner.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/pickup/PickupSpawner.h	(revision 5693)
@@ -39,5 +39,5 @@
 #include <string>
 #include "tools/Timer.h"
-#include "interfaces/Tickable.h"
+#include "tools/interfaces/Tickable.h"
 #include "objects/worldentities/StaticEntity.h"
 
Index: code/trunk/src/orxonox/objects/quest/AddQuest.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/AddQuest.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/quest/AddQuest.h	(revision 5693)
@@ -35,5 +35,5 @@
 #define _AddQuest_H__
 
-#include "OrxonoxPrereqs.h"
+#include "objects/quest/QuestPrereqs.h"
 #include "ChangeQuestStatus.h"
 
@@ -43,19 +43,19 @@
     @brief
         Adds a Quest, resp. changes the quests status to active for the player invoking the Quest.
-        
+
         Creating a AddQuest through XML goes as follows:
-        
+
         <AddQuest questId="id" />  //Where id is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information, and identifies the Quest that should be added.
     @author
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport AddQuest : public ChangeQuestStatus
+    class _QuestExport AddQuest : public ChangeQuestStatus
     {
         public:
         AddQuest(BaseObject* creator);
         virtual ~AddQuest();
-    
+
         virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a AddQuest object through XML.
-    
+
         virtual bool invoke(PlayerInfo* player); //!< Invokes the QuestEffect.
 
Index: code/trunk/src/orxonox/objects/quest/AddQuestHint.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/AddQuestHint.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/quest/AddQuestHint.h	(revision 5693)
@@ -35,5 +35,5 @@
 #define _AddQuestHint_H__
 
-#include "OrxonoxPrereqs.h"
+#include "objects/quest/QuestPrereqs.h"
 
 #include <string>
@@ -45,12 +45,12 @@
     @brief
         Adds a QuestHint, resp. activates the QuestHint of the given id for the player the QuestEffect is invoked on.
-        
+
     Creating a AddQuestHint through XML goes as follows:
-        
+
         <AddQuestHint hintId="id" />  //Where id is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information, and identifies the QuestHint that should be added.
     @author
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport AddQuestHint : public QuestEffect
+    class _QuestExport AddQuestHint : public QuestEffect
     {
         public:
@@ -71,5 +71,5 @@
             inline const std::string & getHintId(void) const
                 { return this->hintId_; }
-            
+
             bool setHintId(const std::string & id); //!< Sets the id of the QuestHint.
 
Index: code/trunk/src/orxonox/objects/quest/AddReward.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/AddReward.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/quest/AddReward.h	(revision 5693)
@@ -35,5 +35,5 @@
 #define _AddReward_H__
 
-#include "OrxonoxPrereqs.h"
+#include "objects/quest/QuestPrereqs.h"
 
 #include <list>
@@ -45,7 +45,7 @@
     @brief
         Adds a list of Rewardables to a player.
-        
+
         Creating a AddReward through XML goes as follows:
-        
+
         <AddReward>
             <Rewardable /> //A list of Rewardable objects to be rewarded the player, see the specific Rewardables for their respective XML representations.
@@ -56,5 +56,5 @@
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport AddReward : public QuestEffect
+    class _QuestExport AddReward : public QuestEffect
     {
         public:
@@ -75,5 +75,5 @@
             inline void addRewardable(Rewardable* reward)
                 { this->rewards_.push_back(reward); }
-        
+
             const Rewardable* getRewardables(unsigned int index) const; //!< Returns the Rewardable object at the given index.
 
Index: code/trunk/src/orxonox/objects/quest/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/objects/quest/CMakeLists.txt	(revision 5692)
+++ code/trunk/src/orxonox/objects/quest/CMakeLists.txt	(revision 5693)
@@ -1,3 +1,3 @@
-ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+SET_SOURCE_FILES(QUEST_SRC_FILES
   AddQuest.cc
   AddQuestHint.cc
@@ -18,2 +18,20 @@
   QuestNotification.cc
 )
+
+ADD_SUBDIRECTORY(notifications)
+
+# add the parent directory for tolua (TODO: remove this if the quest module is moved somewhere else)
+INCLUDE_DIRECTORIES(..)
+
+ORXONOX_ADD_LIBRARY(quest
+  MODULE
+  TOLUA_FILES
+    QuestDescription.h
+    QuestManager.h
+  DEFINE_SYMBOL
+    "QUEST_SHARED_BUILD"
+  LINK_LIBRARIES
+    orxonox
+    overlays
+  SOURCE_FILES ${QUEST_SRC_FILES}
+)
Index: code/trunk/src/orxonox/objects/quest/ChangeQuestStatus.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 5693)
@@ -35,5 +35,5 @@
 #define _ChangeQuestStatus_H__
 
-#include "OrxonoxPrereqs.h"
+#include "objects/quest/QuestPrereqs.h"
 
 #include <string>
@@ -48,5 +48,5 @@
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport ChangeQuestStatus : public QuestEffect
+    class _QuestExport ChangeQuestStatus : public QuestEffect
     {
         public:
@@ -68,5 +68,5 @@
         private:
             std::string questId_; //!< The id of the Quest the status should be changed of.
-            
+
             bool setQuestId(const std::string & id); //!< Sets the id of the Quest.
 
Index: code/trunk/src/orxonox/objects/quest/CompleteQuest.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/CompleteQuest.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/quest/CompleteQuest.h	(revision 5693)
@@ -35,5 +35,5 @@
 #define _CompleteQuest_H__
 
-#include "OrxonoxPrereqs.h"
+#include "objects/quest/QuestPrereqs.h"
 #include "ChangeQuestStatus.h"
 
@@ -43,12 +43,12 @@
     @brief
         Completes a Quest (with a specified id) for the player invoking the QuestEffect.
-        
+
         Creating a CompleteQuest through XML goes as follows:
-        
+
         <CompleteQuest questId="id" />  //Where id is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information, and identifies the Quest that should be completed.
     @author
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport CompleteQuest : public ChangeQuestStatus
+    class _QuestExport CompleteQuest : public ChangeQuestStatus
     {
         public:
Index: code/trunk/src/orxonox/objects/quest/FailQuest.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/FailQuest.h	(revision 5692)
+++ code/trunk/src/orxonox/objects/quest/FailQuest.h	(revision 5693)
@@ -35,5 +35,5 @@
 #define _FailQuest_H__
 
-#include "OrxonoxPrereqs.h"
+#include "objects/quest/QuestPrereqs.h"
 #include "ChangeQuestStatus.h"
 
@@ -43,12 +43,12 @@
     @brief
         Fails a quest (with a specified id) for the player invoking the QuestEffect.
-        
+
         Creating a FailQuest through XML goes as follows:
-        
+
         <FailQuest questId="id" />  //Where id is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information, and identifies the Quest that should be failed.
     @author
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport FailQuest : public ChangeQuestStatus
+    class _QuestExport FailQuest : public ChangeQuestStatus
     {
         public:
